--- old/usr/src/uts/common/os/fio.c	2016-07-13 01:32:40.204451696 -0400
+++ new/usr/src/uts/common/os/fio.c	2016-07-13 01:32:40.213757045 -0400
@@ -838,11 +838,14 @@
  * Duplicate all file descriptors across a fork.
  */
 void
-flist_fork(uf_info_t *pfip, uf_info_t *cfip)
+flist_fork(proc_t *pp, proc_t *cp)
 {
 	int fd, nfiles;
 	uf_entry_t *pufp, *cufp;
 
+	uf_info_t *pfip = P_FINFO(pp);
+	uf_info_t *cfip = P_FINFO(cp);
+
 	mutex_init(&cfip->fi_lock, NULL, MUTEX_DEFAULT, NULL);
 	cfip->fi_rlist = NULL;
 
@@ -860,6 +863,13 @@
 		cufp->uf_alloc = pufp->uf_alloc;
 		cufp->uf_flag = pufp->uf_flag;
 		cufp->uf_busy = pufp->uf_busy;
+
+		if (cufp->uf_file != NULL && cufp->uf_file->f_vnode != NULL) {
+			(void) VOP_IOCTL(cufp->uf_file->f_vnode, F_ASSOCI_PID,
+			    (intptr_t)cp->p_pidp->pid_id, FKIOCTL, kcred,
+			    NULL, NULL);
+		}
+
 		if (pufp->uf_file == NULL) {
 			ASSERT(pufp->uf_flag == 0);
 			if (pufp->uf_busy) {
@@ -945,6 +955,11 @@
 	offset = fp->f_offset;
 
 	vp = fp->f_vnode;
+	if (vp != NULL) {
+		(void) VOP_IOCTL(vp, F_DASSOC_PID,
+		    (intptr_t)(ttoproc(curthread)->p_pidp->pid_id), FKIOCTL,
+		    kcred, NULL, NULL);
+	}
 
 	error = VOP_CLOSE(vp, flag, count, offset, fp->f_cred, NULL);
 
